CREATE OR REPLACE PROCEDURE sql_scan
/*******************************************************
 sql_scan - scans 1 port on a given host and return the
            result.

* First public release *

 to run: SQL> set serveroutput on
         SQL> exec sql_scan( dest => 'target', tcp_port => 'port');

 - MadByte

$Id: sql_scan.sql 21 2005-03-09 22:10:17Z oracle $
$Rev: 21 $
*******************************************************/

(
  dest       	varchar2 := 'www.binken.com',
  tcp_port    	varchar2 := '1',
  v		varchar2 := 'off',
  version     	varchar2 := 'off')
AS
 c   utl_tcp.connection;
 len PLS_INTEGER;
 found NUMBER;
 port_found EXCEPTION;
 eip NUMBER;
 msg VARCHAR2(255);

     BEGIN
     eip := tcp_port;
     c := utl_tcp.open_connection(remote_host => dest, remote_port => tcp_port);
     dbms_output.put_line('*** Open port '|| tcp_port);
     found := 1;
     IF v = 'on' THEN  -- do banner grab, more added l8r here ;)
 	len := utl_tcp.write_line(c, 'HEAD / HTTP/1.0'); 
 	len := utl_tcp.write_line(c, 'help');  
  	len := utl_tcp.write_line(c);
     BEGIN
     	LOOP
     		-- dbms_output.put_line('PORT BANNER:');
     		msg := utl_tcp.get_line(c, TRUE); -- get result
     		IF msg IS NOT NULL THEN
     			IF (owa_pattern.match(msg, 'Server.*')) THEN
     				dbms_output.put_line(msg);  -- print result
     			END IF;
     		ELSE
     			dbms_output.put_line(msg);
     		END IF;
     	END LOOP;
     	EXCEPTION
     	WHEN utl_tcp.end_of_input THEN
      		NULL; -- end of input
     END;
     END IF;	
     utl_tcp.close_connection(c);
     EXCEPTION
     WHEN utl_tcp.network_error THEN
     IF found = 1 THEN
         dbms_output.put_line('');
     ELSE
         IF v = 'on' THEN
         		dbms_output.put_line('');
         	-- dbms_output.put_line('Port closed  '|| eip);
     	 END IF;
     END IF;
     WHEN OTHERS THEN           -- default handler
       NULL;
     END;
/
