CREATE OR REPLACE PROCEDURE sqlmap
/*************************************************************
 sqlmap - TCP connect port scanner 
 
* First public release *

 PREREQUISITES: Procedure sql_scan() must be loaded.

 to run in sqlplus : SQL> SET TIMING ON;
         	     SQL> set serveroutput on
                     SQL> exec sqlmap( dest => 'target', tcp_from => 'port', tcp_to => 'port');
 e.g. exec sqlmap ( target => 'www.binken.com', tcp_from => '62', tcp_to => '82');
 - MadByte

$Id: sqlmap.sql 21 2005-03-09 22:10:17Z oracle $ 
$Rev: 21 $
**************************************************************/
-- defaults
(
  target      varchar2 := 'www.binken.com',
  verbose     varchar2 := 'off',
  tcp_from    varchar2 := '78',
  tcp_to      varchar2 := '81')
AS
 time1 NUMBER;
 time2 NUMBER;
 error NUMBER;
 t_max NUMBER := 65535;
 t_min NUMBER := 1;
 PORT_RANGE_ERROR EXCEPTION;
 NULL_ERROR EXCEPTION;
 version varchar2(4) := 'v0.1';

     BEGIN
         time1:=dbms_utility.get_time;
	 error := 0;
	BEGIN --handle errors
	 IF tcp_to > t_max OR tcp_from < t_min THEN
		raise PORT_RANGE_ERROR;
	 END IF;
       EXCEPTION 
	 WHEN PORT_RANGE_ERROR THEN
		dbms_output.put_line(' Error: You can only scan ports within the following range [1-65535] ');
		error := 1;
	 WHEN NULL_ERROR THEN 
	        dbms_output.put_line(' Error: You must give values to <target> <tcp_from> and <tcp_to>');
		error := 1;
       END;
	 IF error = 0 THEN
         dbms_output.put_line(' ****************** P/L SQL portscanner ******************* ');
         dbms_output.put_line(' version: ' || version);
         dbms_output.put_line(' ');
         dbms_output.put_line(' Host: ' || target);
         dbms_output.put_line(' Portrange: '|| tcp_from ||'-' || tcp_to);
         dbms_output.put_line(' ');
         dbms_output.put_line(' ********************************************************** ');
         FOR i IN tcp_from..tcp_to LOOP
          sql_scan(dest => target, tcp_port => i, v => verbose); -- do the scan 
         END LOOP;
         time2:=dbms_utility.get_time;
  	 dbms_output.put_line('time elapsed in ms: ' || (time2-time1) /100*1000 );
	 END IF;

       EXCEPTION
         WHEN OTHERS THEN           -- default handler
       NULL;
      END;
/
